//
//      Nico.c
//

#include "AEEModGen.h"      // W[ C^[tFCX̐錾
#include "AEEAppGen.h"      // Avbg C^[tFCX̐錾
#include "AEEShell.h"       // VF C^[tFCX̐錾
#include "AEEGraphics.h"    // OtBbN C^[tFCX̐錾

#include "Nico.bid"


// jR` Avbg\
typedef struct
{
    AEEApplet   a;          // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱
    IGraphics*  graphics;   // IGraphics IuWFNg
    boolean     pressed;    // L[ꂽԂ
} NicoApplet;


// O錾
static boolean Nico_HandleEvent(NicoApplet * app, AEEEvent eCode, 
                                uint16 wParam, uint32 dwParam);

static boolean Nico_OnAppStart(NicoApplet* app);
static boolean Nico_OnAppStop(NicoApplet* app);
static boolean Nico_OnAppSuspend(NicoApplet* app);
static boolean Nico_OnAppResume(NicoApplet* app);
static boolean Nico_OnKey(NicoApplet* app, uint16 key);
static boolean Nico_OnKeyPress(NicoApplet* app, uint16 key);
static boolean Nico_OnKeyRelease(NicoApplet* app, uint16 key);
static void Nico_DrawFace(NicoApplet* app);


//
//  Avbg쐬ƂɌĂяo܂B
//
int AEEClsCreateInstance(AEECLSID ClsId,IShell * pIShell,IModule * po,void ** ppObj)
{
    *ppObj = NULL;
    
    if (ClsId == AEECLSID_NICO){
        if (AEEApplet_New(sizeof(NicoApplet), ClsId, pIShell, po, (IApplet**)ppObj,
            (AEEHANDLER)Nico_HandleEvent, NULL) == TRUE) 
        {
            // Avbg\̂
            NicoApplet* app = (NicoApplet*)(*ppObj);
            app->pressed = FALSE;

            return AEE_SUCCESS;
        }
    }
    return (EFAILED);
}


//
//  Cxg nh
//
static boolean Nico_HandleEvent(NicoApplet* app, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{  
    switch (eCode) 
    {
    case EVT_APP_START:
        return Nico_OnAppStart(app);

    case EVT_APP_STOP:
        return Nico_OnAppStop(app);

    case EVT_APP_SUSPEND:
        return Nico_OnAppSuspend(app);

    case EVT_APP_RESUME:
        return Nico_OnAppResume(app);

    case EVT_KEY:
        return Nico_OnKey(app, wParam);

    case EVT_KEY_PRESS:
        return Nico_OnKeyPress(app, wParam);

    case EVT_KEY_RELEASE:
        return Nico_OnKeyRelease(app, wParam);
            
    default:
        break;
    }
    return FALSE;
}


//
//  AvbgJnƂɌĂяo
//
static boolean Nico_OnAppStart(NicoApplet* app)
{
    IShell* shell = app->a.m_pIShell;

    // IGraphics IuWFNg擾
    ISHELL_CreateInstance(shell, AEECLSID_GRAPHICS, &app->graphics);
    if (app->graphics == NULL) 
        return FALSE;

    // ʕ`
    Nico_DrawFace(app);

    return TRUE;
}


//
//  AvbgIƂɌĂяo
//
static boolean Nico_OnAppStop(NicoApplet* app)
{
    // IGraphics IuWFNg
    IGRAPHICS_Release(app->graphics);

    return TRUE; 
}


//
//  AvbgfƂɌĂяo
//
static boolean Nico_OnAppSuspend(NicoApplet* app)
{
    // TXyhOɃL[Ԃ
    app->pressed = FALSE;

    return TRUE;
}


//
//  AvbgĊJƂɌĂяo
//
static boolean Nico_OnAppResume(NicoApplet* app)
{
    // ʕ`
    Nico_DrawFace(app);

    return TRUE;
}


//
//  L[ꂽƂɌĂяoB
//
static boolean Nico_OnKey(NicoApplet* app, uint16 key)
{
    if (key == AVK_SOFT2) {
        ISHELL_CloseApplet(app->a.m_pIShell, TRUE);
        return TRUE;
    }
    if (key == AVK_SOFT1) {
        ISHELL_StartApplet(app->a.m_pIShell, 0x1234);
    }

    return FALSE;
}


//
//  L[ꂽƂɌĂяo
//
static boolean Nico_OnKeyPress(NicoApplet* app, uint16 key)
{
    if (key == AVK_SELECT) {
        app->pressed = TRUE;
        Nico_DrawFace(app);
        return TRUE;
    }
    return FALSE;
}


//
//  L[Ԃ痣ꂽƂɌĂяo
//
static boolean Nico_OnKeyRelease(NicoApplet* app, uint16 key)
{
    if (key == AVK_SELECT) {
        app->pressed = FALSE;
        Nico_DrawFace(app);
        return TRUE;
    }
    return FALSE;
}



//
//  jR``悷֐
//
//  NicoApplet.pressed  FALSE ȂΏ΂A
//  TRUE ȂΓ{\B
//
static void Nico_DrawFace(NicoApplet* app)
{
    IGraphics* g = app->graphics;
    AEECircle c;
    AEELine* lines;

    AEELine nico_lines[] = { // ΂̐e[u
        { 45, 40, 45, 48 },
        { 55, 40, 55, 48 },
        { 40, 55, 50, 60 },
        { 60, 55, 50, 60 },
        { -1, -1, -1, -1 }
    };

    AEELine pun_lines[] = {  // {̐e[u
        { 35, 35, 45, 45 },
        { 65, 35, 55, 45 },
        { 35, 60, 65, 60 },
        { -1, -1, -1, -1 }
    };

    // ̕`Fɐݒ
    IGRAPHICS_SetColor(g, 0, 0, 0, 0);

    // hԂ[hɐݒ
    IGRAPHICS_SetFillMode(g, TRUE);

    // ʑŜ𔒂ŃNA
    IGRAPHICS_SetBackground(g, 255, 255, 255);
    IGRAPHICS_ClearViewport(g);


    // ̐Fݒ
    if (app->pressed) {
        IGRAPHICS_SetFillColor(g, 255, 0, 0, 0);
    }
    else {
        IGRAPHICS_SetFillColor(g, 255, 255, 0, 0);
    }

    // ̉~`
    c.cx = 50;
    c.cy = 50;
    c.r  = 20 + (app->pressed ? 10 : 0);
    IGRAPHICS_DrawCircle(g, &c);


    // ̖ڂƌ`
    lines = (app->pressed) ? pun_lines : nico_lines;
    while ((*lines).sx != -1) {
        IGRAPHICS_DrawLine(g, lines);
        lines++;
    }

    // ۂɉʂɕ\
    IGRAPHICS_Update(g);

}



